#version 330 core

// Interpolated values from the vertex shaders
//in vec3 fragmentColor;

in vec2 fragmentUV;
in vec3 normal_cs;
in vec3 lightdirection_cs[5];
in vec3 position_ws;
in vec3 eyedirection_cs;

out vec4 fragColor;

uniform sampler2D colorTexture;
uniform mat4 modelMatrix;
uniform mat4 viewMatrix;
uniform vec3 lightposition_ws[5];

vec4 spotDir = vec4(0, -1, 0, 1);
float spotCutOff = 0.61;


void main(void){
//	const vec3 lightposition_ws[5] = vec3[5](vec3(0.0, 9.0, -8.0), vec3(0.0, 9.0, -32.0), vec3(0.0, 9.0, -56.0), vec3(0.0, 9.0, -80.0), vec3(0.0, 9.0, -104.0));


	vec4 textureColor = texture2D(colorTexture, fragmentUV);
	vec4 materialColor = textureColor; //vec4(textureColor, 1.0);
	vec4 ambient = vec4(0.5, 0.5, 0.5, 1) * materialColor;
	vec4 specular = vec4(0.3, 0.3, 0.3, 1);
	vec4 lightColor = vec4(1.0, 1.0, 1.0, 0.0);
	float lightPower = 1.0f;
	//mat4 mv = viewMatrix * modelMatrix;

	fragColor = ambient;
	vec4 color = lightColor * lightPower * materialColor;
	vec3 sd = normalize(vec3(-spotDir));

	vec3 ed = normalize(eyedirection_cs);
	vec3 n = normalize(normal_cs);

	//float backface = dot(n, ed);
	//if (backface < 0.3) {
	//	fragColor = vec4(0, 0, 0, 1);
	//}

	for (int u = 0; u < lightposition_ws.length(); ++u) {

		vec3 ld = normalize(lightdirection_cs[u]);

		if(dot(sd, ld) > spotCutOff) {
			//vec3 l = normalize(lightdirection_cs[u]);
			float cosTheta = dot(n, ld );
			
			if (cosTheta > 0.95)
				color *= 1.0;
			else if (cosTheta > 0.5)
				color *= 0.5;
			else if (cosTheta > 0.25)
				color *= 0.25;
			else
				color *= 0.05;

			//if (color > ambient)
				fragColor += color;
		}
		
		// Distance to the light
		//float distance = length(lightposition_ws[u] - position_ws);
		//if (distance > 15) {
		//	continue;
		//}
		
		
	}			
}